﻿// TODO: list mode. fix drag & drop.
/*
	TODO:
		* Fix drag&drop
		* List mode fixes: hilite/move items? plus at bottom?
*/

var openPage = 1, flipped;

/* Event handlers */
function load () {	
	var c = parseInt(trim(widget.system('ps auxww | grep -c "[N]otebook.wdgt"',null).outputString));
	if (c>1) document.location.href='oneatatime.html';
	
	Notebook.checkForHome();
	loadLanguage();
	
	var prefWidth = widget.preferenceForKey("pad-width");
	var prefHeight = widget.preferenceForKey("pad-height");
	
	if (prefWidth && prefWidth > 0 && prefHeight && prefHeight > 0) {
		window.width = prefWidth;
		window.height = prefHeight;
		window.resizeTo(prefWidth, prefHeight);
	}
	
	loadFontPopup();
	document.getElementById("fontface").value = widget.preferenceForKey("font-face");
	document.getElementById("fontsize").value = widget.preferenceForKey("font-size");
	document.getElementById("theme").selectedIndex = widget.preferenceForKey("theme");
	
	if (widget.preferenceForKey("font-face") == undefined)
		document.getElementById("fontface").value = "Lucida Grande";
		
	if (widget.preferenceForKey("font-size") == undefined)
		document.getElementById("fontsize").value = "11 pt";
		
	if (widget.preferenceForKey("theme") == undefined)
		document.getElementById("theme").selectedIndex = 0;
	
	var prefPage = widget.preferenceForKey("open-page");
	
	var pageToShow = 1;
	if (prefPage && prefPage > 0 ) {
		pageToShow = prefPage;
	}
	
	setFont();
	setTheme();
	checkiPod();
	
	if (Notebook.storedRegistrationValid())
		hideStickers();
	
	if (widget.preferenceForKey('lock-enabled')) {
		toggleVisibility('closed');
		toggleVisibility('front');
	}
	
	// Load the first page
	openPage = pageToShow;
	loadPage(pageToShow);
	loadPageSelector();
}

function store() {
	savePage(openPage);
}






/* Neat fade effects */
var showControls;

function doBlur() {
	store();
	showControls = false;
	doFade();
}

function doFocus() {
	showControls = true;
	doFade();
	checkiPod();
	
	if (isDrawing)
		replay();
}

/*
	since the dashboard sucks at giving focus, we need 
	a few extra checks
*/

function extraFocus() {
	if (!showControls)
		doFocus();
}


var fTools, fControls, fHider;

function doFade() {
	clearInterval(fTools);
	clearInterval(fControls);
	clearInterval(fHider);
	fHider		= qfade("toolhider");
	fTools		= qfade("tools");	
	fControls	= qfade("bottomcontrols");	
}

function getTO() {
 	if (showControls)
		return 1;
	else
		return 0;
}

window.onblur = doBlur;
window.onfocus = doFocus;
widget.onhide = store;
widget.onremove = store;

var help_canvas;








/* Languages */

var language = "english";
function loadLanguage() {
	var l = widget.system('defaults read "Apple Global Domain" AppleLanguages',null).outputString;
	language = getLanguageToUse(splitLanguages(l));
	
	document.getElementById("deltext").innerHTML = getLocalString("delete sure");
	document.getElementById("delok").innerHTML = getLocalString("delete");
	document.getElementById("delcancel").innerHTML = getLocalString("cancel");
		
	document.getElementById("deleteicon").title = getLocalString("delete");
	document.getElementById("gearicon").title = getLocalString("print");
	document.getElementById("newicon").title = getLocalString("new page");
	document.getElementById("searchicon").title = getLocalString("search notes");
	
	document.getElementById("fontsizelabel").innerHTML = getLocalString("font size");
	
	document.getElementById("titlemenuitem").innerHTML = getLocalString("select action");
	document.getElementById("revertmenuitem").innerHTML = getLocalString("can't revert");
	document.getElementById("savemenuitem").innerHTML = getLocalString("can't save");
	document.getElementById("saveasmenuitem").innerHTML = getLocalString("save as")+'...';
	document.getElementById("printmenuitem").innerHTML = getLocalString("print")+'...';
	
	document.getElementById("ipodtext").innerHTML = getLocalString("ipodtext");
	document.getElementById("syncnow").innerHTML = getLocalString("syncnow");
	document.getElementById("syncauto").innerHTML = getLocalString("syncauto");
	
	document.getElementById("newtextmenuitem").innerHTML = getLocalString("new text page");
	document.getElementById("newdrawmenuitem").innerHTML = getLocalString("new drawing page");
	document.getElementById("newlistmenuitem").innerHTML = getLocalString("new list page");
	
}

function splitLanguages(list) {
	var list = list.substr(1);
	list = list.substr(0,list.length-1);
	var langs = list.split(",");
	
	return langs;
}

function getLanguageToUse(langs) {
	for (var i = 0; i < langs.length; i++) {
		var l = langs[i];
		
		if (l.charAt(0) == ' ')
			l = l.substr(1);
		
		switch (l) {
			case "en":
				return "english";
			case "English":
				return "english";
				
			case "sv":
				return "swedish";
			case "Swedish":
				return "swedish";
				
			case "fr":
				return "french";
			case "French":
				return "french";
		}
	}
	
	return "english";
}

function getLocalString(value) {
	
	switch (value) {
		
		case "select action":
			if (language == "english")
				return "Select an action:";
			else if (language == "french")
				return "Choisissez une commande:";
			else if (language == "swedish")
				return "Markera ett kommando:";
	
		case "revert":
			if (language == "english")
				return "Revert";
			else if (language == "french")
				return "Retournez";
			else if (language == "swedish")
				return "Återgå till sparat";
				
		case "can't revert":
			if (language == "english")
				return "(Can't Revert)";
			else if (language == "french")
				return "(Ne peut pas retourner)";
			else if (language == "swedish")
				return "(Kan inte återgå)";

		case "save":
			if (language == "english")
				return "Save                                         ⌘S";
			else if (language == "french")
				return "Enregistrer                                        ⌘S";
			else if (language == "swedish")
				return "Spara                                         ⌘S";
	
		case "can't save":
			if (language == "english")
				return "(Already Saved)";
			else if (language == "french")
				return "(Déjà enregistré)";
			else if (language == "swedish")
				return "(Redan sparat)";
	
		case "save as":
			if (language == "english")
				return "Save as...                      ⌘⇧S";
			else if (language == "french")
				return "Enregistrer sous...                      ⌘⇧S";
			else if (language == "swedish")
				return "Spara som...                      ⌘⇧S";
	
		case "can't save as":
			if (language == "english")
				return "(Can't export drawings)";
			else if (language == "french")
				return "(Ne peut pas économiser as)";
			else if (language == "swedish")
				return "(Kan inte exportera teckningar)";
				
		case "print":
			if (language == "english")
				return "Print...                                   ⌘P";
			else if (language == "french")
				return "Imprimer...                                   ⌘P";
			else if (language == "swedish")
				return "Skriv ut...                                   ⌘P";

		case "can't print":
			if (language == "english")
				return "(Can't print drawings)";
			else if (language == "french")
				return "(Ne peut pas imprimer)";
			else if (language == "swedish")
				return "(Kan inte skriva ut teckningar)";
	
		case "font size":
			if (language == "english")
				return "Font size:";
			else if (language == "french")
				return "Taille des textes";
			else if (language == "swedish")
				return "Textstorlek";
	
		case "new page":
			if (language == "english")
				return "New page";
			else if (language == "french")
				return "Nouvelle page";
			else if (language == "swedish")
				return "Ny sida";
		
		case "delete sure":
			if (language == "english")
				return "Are you sure you want to delete this page?";
			else if (language == "french")
				return "Êtes-vous sûr de vouloir supprimer cette page?";
			else if (language == "swedish")
				return "Är du säker på att du vill radera sidan?";
				
		case "print sure":
			if (language == "english")
				return "Are you sure you want to print this page?";
			else if (language == "french")
				return "Êtes-vous sûr de vouloir imprimer cette page?";
			else if (language == "swedish")
				return "Är du säker på att du vill skriva ut sidan?";
				
		case "delete":
			if (language == "english")
				return "Delete";
			else if (language == "french")
				return "Effacer";
			else if (language == "swedish")
				return "Radera";
				
		case "cancel":
			if (language == "english")
				return "Cancel";
			else if (language == "french")
				return "Annuler";
			else if (language == "swedish")
				return "Avbryt";
		
		case "search notes":
			if (language == "english")
				return "Search notes";
			else if (language == "french")
				return "Chercher";
			else if (language == "swedish")
				return "Sökning";

		case "daysleft_pre":
			if (language == "english")
				return "";
			else if (language == "french")
				return "Vous allez pouvoir utiliser ";
			else if (language == "swedish")
				return "";
		
		case "daysleft_mid":
			if (language == "english")
				return " will run without payment for ";
			else if (language == "french")
				return " de manière illimitée pour encore ";
			else if (language == "swedish")
				return " kommer att fortsätta fungera gratis i ";
		
		case "daysleft_post":
			if (language == "english")
				return " more day";
			else if (language == "french")
				return " jour";
			else if (language == "swedish")
				return " dag";
		
		case "daysleft_plural":
			if (language == "english")
				return "s";
			else if (language == "french")
				return "s";
			else if (language == "swedish")
				return "ar";
		
		case "daysleft_thanks":
			if (language == "english")
				return "Thanks for using Notebook!";
			else if (language == "french")
				return "Merci d'utiliser Notebook!";
			else if (language == "swedish")
				return "Tack för att du använder Notebook!";
		
		case "buy":
			if (language == "english")
				return "Buy";
			else if (language == "french")
				return "Acheter";
			else if (language == "swedish")
				return "Köp";
		
		case "register":
			if (language == "english")
				return "Register";
			else if (language == "french")
				return "Enregistrer";
			else if (language == "swedish")
				return "Registrera";
				
				
		case "ipodtext":
			if (language == "swedish")
				return "Notebook kan kopiera dina anteckningar till din iPod";
			else
				return "Notebook can sync your notes onto your iPod";
				
		case "syncnow":
			if (language == "swedish")
				return "Kopiera nu";
			else
				return "Sync now";
				
		case "syncauto":
			if (language == "swedish")
				return "  Kopiera automatiskt";
			else
				return "  Sync automatically";
				
		case "copiedok":
			if (language == "swedish")
				return "Dina anteckningar har kopierats till din iPod!";
			else
				return "Your notes have now been copied to your iPod!";
				
		case "copiedng":
			if (language == "swedish")
				return "Kunde inte kopiera till iPod, ett fel uppstod: ";
			else
				return "I could not copy the notes to your iPod, because I ";
				
		case "new text page":
			if (language == "swedish")
				return "Nytt textblad           ⌘N";
			else
				return "New text page           ⌘N";
				
		case "new drawing page":
			if (language == "swedish")
				return "Ny teckning          ⌘⇧N";
			else
				return "New drawing          ⌘⇧N";
				
		case "new list page":
			if (language == "swedish")
				return "Ny lista                     ⌘⌥N";
			else
				return "New list                     ⌘⌥N";
				
		case "untitled text page":
			if (language == "swedish")
				return "Nytt textblad";
			else
				return "Untitled text page";
				
		case "untitled drawing page":
			if (language == "swedish")
				return "Ny teckning";
			else
				return "Untitled drawing";
				
		case "untitled list page":
			if (language == "swedish")
				return "Ny lista";
			else
				return "Untitled list";
				
				
		case "cant save as message":
			if (language == "swedish")
				return "Tyvärr så kan inte Notebook Widget exportera teckningar.";
			else
				return "Sorry, but Notebook Widget cannot export drawings.";
				
		case "cant print message":
			if (language == "swedish")
				return "Tyvärr så kan inte Notebook Widget skriva ut teckningar.";
			else
				return "Sorry, but Notebook Widget cannot print drawings.";
	}
	
}








/* Page managing */

// Save this page, and load another.
function goPage(num) {
	savePage(openPage);
	openPage = num;
	loadPage(openPage);
}

var isList = false;
var isDrawing = false;
// Load a page from disk and display it, or create a new page if it didn't exist.
function loadPage(page) {
	var title = Notebook.readPageTitle("Page"+page);
	var data = Notebook.readPage("Page"+page);

	forceRepaint();
	isList = false;
	isDrawing = false;
	if (title != undefined && title.indexOf("[List]")>-1) {
		title = trim(title.replace("[List]",""));
		isList = true;
		document.getElementById("title").value = title;
		document.getElementById("edittab").style.display = "block";
		document.getElementById("listtab").style.display = "block";
		document.getElementById("drawtab").style.display = "none";
		showDrawingTools(false);
		document.getElementById("edit").value = data;
		replayList();
		showCurrentPage();
	} else if (title != undefined && title.indexOf("[Drawing]")>-1) {
		title = trim(title.replace("[Drawing]",""));
		isDrawing = true;
		document.getElementById("title").value = title;
		document.getElementById("edittab").style.display = "block";
		document.getElementById("drawtab").style.display = "block";
		document.getElementById("listtab").style.display = "none";
		fixCanvasSize();
		alert(document.getElementById('draw').offsetWidth);

	showDrawingTools(true);
		document.getElementById("edit").value = data;
		setupDraw();
		replay();
		showCurrentPage();
	} else if (title != undefined) {
			
		document.getElementById("title").value = title;
		document.getElementById("edit").value = data;
		if (!data)
			document.getElementById("edit").value = title;
		document.getElementById("edittab").style.display = "block";
		document.getElementById("drawtab").style.display = "none";
		document.getElementById("listtab").style.display = "none";
		showDrawingTools(false);
		showCurrentPage();
	} else {
		document.getElementById("title").value = getLocalString("new page")+" "+openPage;
		document.getElementById("edit").value = '';
		document.getElementById("edittab").style.display = "block";
		document.getElementById("drawtab").style.display = "none";
		document.getElementById("listtab").style.display = "none";
		showDrawingTools(false);
		savePage(openPage);
		loadPageSelector();
	}
	
	if (isDrawing) {
		document.getElementById('saveasmenuitem').innerHTML=getLocalString("can't save as");
		document.getElementById('printmenuitem').innerHTML=getLocalString("can't print");
	} else {
		document.getElementById('saveasmenuitem').innerHTML=getLocalString("save as");
		document.getElementById('printmenuitem').innerHTML=getLocalString("print");
	}
	
	widget.setPreferenceForKey(openPage, "open-page");
	
	document.getElementById('revertmenuitem').innerHTML=getLocalString("can't revert"); //"(Can't revert)";
	document.getElementById('savemenuitem').innerHTML=getLocalString("can't save");     //"(Already Saved)";
	
	// we don't want to keep the user waiting, so let's thread these as well
	setTimeout("updateNav()",6);
}

function showDrawingTools(b) {
	if (b) {
		document.getElementById("pencolor").style.display = "block";
		document.getElementById("pensize").style.display = "block";
	} else {
		document.getElementById("pencolor").style.display = "none";
		document.getElementById("pensize").style.display = "none";
	}		
}

function updateNav() {
	if (openPage == 1) 
		document.getElementById("prev").style.opacity = "0.2";
	else
		document.getElementById("prev").style.opacity = "0.5";
	
	if ( pageExists(openPage+1) )
		document.getElementById("next").style.opacity = "0.5";
	else
		document.getElementById("next").style.opacity = "0.2";
}

// Save a page to disk.
function savePage(page) {
	if (isList) {
		saveItems();
	}

	var title = document.getElementById("title").value;
	var txt = document.getElementById("edit").value;
	
	if (page>0 && txt!='') {
		
		if (isDrawing)
			title += ' [Drawing]';
		
		if (isList)
			title += ' [List]';
		
		Notebook.savePage(title+"\n"+txt, "Page"+page);
		updatePageSelector(page);
		document.getElementById('revertmenuitem').innerHTML=getLocalString("can't revert");
		document.getElementById('savemenuitem').innerHTML=getLocalString("can't save");
	}
}

// Delete a page from disk
function deletePage(page) {
	Notebook.deletePage(page);
	
	loadPageSelector();
	if ( (!pageExists(openPage)) && openPage>1) {
		openPage--;
	}
	loadPage(openPage);
}

function hasChanged() {
	if (document.getElementById('revertmenuitem').innerHTML != getLocalString("revert")) {
		document.getElementById('revertmenuitem').innerHTML = getLocalString("revert");
		document.getElementById('savemenuitem').innerHTML = getLocalString("save");
	}

}

function getTitle(page) {
	var data = Notebook.readPageTitle("Page"+page);
	
	if (data != undefined) {
		return trim(data.replace('[List]','').replace('[Drawing]',''));
	} else {
		return "empty";
	}
}

function titlePress(event) {
	if (event.keyCode==13) {
		if (isList) {
			document.getElementById("listcontents").childNodes[1].childNodes[1].focus();
		} else if (!isDrawing) { 
			document.getElementById("edit").focus();
		}
		
		return false;
	}
	
	hasChanged();
	return true;
}

/* Misc. file managing */

// Where to save pages?
function getFileName(page) {
	return "~/Library/Notebook/Page"+page+".txt";
}

// Does a page exist on disk?
function pageExists(p) {
	return Notebook.pageExists("Page"+p);
}












/* Search */

var searchOpen = false;
function togglesearch(opening) {
	searchOpen = !searchOpen;
	store();
	
	setVisibility("tools", !opening);
	setVisibility("controls", !opening);
	
	setVisibility("edittab", !opening);
	if (isDrawing) {
		setVisibility("drawtab", !opening);
		replay();
	}
	if (isList) {
		setVisibility("listtab", !opening);
	}

	setVisibility("searchtab", opening);
	
	
	if (opening == true)
		document.getElementById("searchtext").focus();
}

function showresult(page) {
	togglesearch();
	goPage(page);
}

var grepProc;
function doSearch() {
	if (grepProc != undefined) {
		grepCompleted();
		grepProc.cancel();
	}
	
	var searchstring = document.getElementById("searchtext").value;
	
	if (searchstring == "") {
		parseGrep("");
		return;
	}
	
	/*
		Multi-byte search support (asian text keke ^_^)
	*/
	
	var writing = widget.system("/bin/cat > ~/Library/Caches/NotebookSearch",forceAsync);
	writing.write(searchstring);
	writing.close();
	
	grepProc = widget.system("grep -i -m 1 -f ~/Library/Caches/NotebookSearch ~/Library/Notebook/* | sort",grepCompleted);
}

function grepCompleted() {
	parseGrep(grepProc.outputString);
}

function parseGrep(grepOutput) {
	var results = document.getElementById("searchresults");
	var s = "<br>";
	
	if (grepOutput != undefined) {
		var resultarray = grepOutput.split("\n");
		
		for (var i = 0; i < resultarray.length; i++) {
			var line = resultarray[i];
			var delim = line.indexOf(":");
			var path = line.substr(0,delim);
			var foundLine = line.substr(delim+1);
			
			j = path.lastIndexOf("e"); // e as in Page
			
			if (j > 0) {
				p = parseInt(path.substr(j+1,3));
				
				if (p != NaN && Notebook.readPageTitle("Page"+p).indexOf('[Drawing]')==-1) {
					link = "<b>" + p + ".</b> " + foundLine; //getTitle(p);
					link = link.link("javascript:showresult("+p+")");
					s = s + link + "<br> \n";
				}
			}
		}
	}
	
	results.innerHTML = s;
}










/* Manage the page selector */
function loadPageSelector() {
	var eDiv = document.getElementById("pagePopup");
	eDiv.options.length = 0;
	
	for (var p = 1; pageExists(p); p++) {
		eDiv.options[p-1] = new Option(p+". " + getTitle(p),p);
	}
	showCurrentPage();
}

function updatePageSelector(p) {
	var eDiv = document.getElementById("pagePopup");
	eDiv.options[p-1] = new Option(p+". " + getTitle(p),p);
	showCurrentPage();
}

function showCurrentPage() {
	document.getElementById("pagePopup").value = openPage;
	document.getElementById("pagenumber").innerHTML = openPage;
}








/* Page flippers */

// Next page flipper
function nextPage() {
	if ( pageExists(openPage+1) )
		goPage(parseInt(openPage)+1);
}

// Previous page flipper
function prevPage() {
	if (openPage > 1) {
		goPage(parseInt(openPage)-1);
	}
}

function newPage() {
	goPage( document.getElementById("pagePopup").options.length +1 );
	document.getElementById("title").value = getLocalString("untitled text page")+" "+openPage;
	document.getElementById("edit").value = "Blank page";
	savePage(openPage);
	loadPage(openPage);
}

function newDrawingPage() {
	goPage( document.getElementById("pagePopup").options.length +1 );
	document.getElementById("title").value = getLocalString("untitled drawing page")+" "+openPage;
	document.getElementById("title").value += " [Drawing]";
	document.getElementById("edit").value = "Drawing";
	savePage(openPage);
	loadPage(openPage);
}

function newListPage() {
	goPage( document.getElementById("pagePopup").options.length +1 );
	document.getElementById("title").value = getLocalString("untitled list page")+" "+openPage;
	document.getElementById("title").value += " [List]";
	document.getElementById("edit").value = "• Untitled";
	savePage(openPage);
	loadPage(openPage);
}


function newPageType(list) {
	var opt = list.selectedIndex;
	list.selectedIndex=0;
	
	if (opt==0)
		return;
	else if (opt==1)
		newPage();
	else if (opt==2)
		newDrawingPage();
	else if (opt==3)
		newListPage();
}

function newPageDrop(event)  {
	var text = null;
	
	try {
	    text = event.dataTransfer.getData("text/plain");	
	} catch (ex)	{	}
	
	if (text) {
		newPage();
		document.getElementById("title").value = "Dropped text";
		document.getElementById("edit").value = text;
		doUpdateTitle()
	}

	event.stopPropagation();
	event.preventDefault();
}


function dragenter (event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragover (event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event) {
	event.stopPropagation();
	event.preventDefault();
}









/* Gear */

function moreTools(list) {
	var opt = list.selectedIndex;
	list.selectedIndex=0;
	
	if (opt==1) {
		undo();
	} else if (opt==2) {
		savePage(openPage);
	} else if (opt==3) {
		saveAs();
	} else if (opt==4) {
		printPage(openPage);
	}
	
}

function undo() {
	document.getElementById("title").value = getTitle(openPage);
	document.getElementById("edit").value = Notebook.readPage("Page"+openPage);
	document.getElementById('revertmenuitem').innerHTML = getLocalString("can't revert");
	
	if (isDrawing)
		replay();
}

function saveAs() {
	if (isDrawing) {
		resultDialog(getLocalString("cant save as message"));
		return;
	}
	
	if (isList) {
		saveItems();
	}
	
	Notebook.savePage(document.getElementById("edit").value, "Save");
	widget.system('./NotebookHelper.app/Contents/MacOS/NotebookHelper',null);
}

function printPage(page) {
	if (isDrawing) {
		resultDialog(getLocalString("cant print message"));
		return;
	}
	
	Notebook.savePage(document.getElementById("edit").value, "Print");
	widget.system('./NotebookHelper.app/Contents/MacOS/NotebookHelper',null);
}







/* iPod Sync */

function iPodQuery() {
	toggleVisibility("controls");
	toggleVisibility("searchicon");
	toggleVisibility("gearicon");
	toggleVisibility("deleteicon");
	toggleVisibility("newicon");

	document.getElementById('syncnowcheck').className = (widget.preferenceForKey("autosync")=='yes')?'checkbuttonx':'checkbutton';
	toggleVisibility("ipoddialog");
}

var iPod = "";
function checkiPod() {
	var new_iPod = Notebook.discoveriPod();
	if (new_iPod=="") {
		document.getElementById('ipodicon').style.display="none";
		document.getElementById('gearicon').style.right="6.1em";
		document.getElementById('geariconmenu').style.right="6.5em";
		document.getElementById('toolhider').style.width="5.4em";
	} else {
		document.getElementById('ipodicon').style.display="block";
		document.getElementById('gearicon').style.right="7.1em";
		document.getElementById('geariconmenu').style.right="7.5em";
		document.getElementById('toolhider').style.width="6.4em";
	}
	
	if (iPod != new_iPod) {
		if (widget.preferenceForKey("autosync")=="yes") {
			synciPod(true);
		}
		
		iPod = new_iPod;
	}
}

function toggleAutoSync() {
	var setTo = ((widget.preferenceForKey("autosync")=="yes")?"no":"yes");
	widget.setPreferenceForKey(setTo, "autosync");
	document.getElementById('syncnowcheck').className = ((setTo=='yes')?'checkbuttonx':'checkbutton');
}

function synciPod(background) {
	var result = Notebook.copyToiPod();
	
	if (!background || result != "ok") {
		if (result=="ok")
			result=getLocalString('copiedok');
		else
			result=getLocalString('copiedng')+result+".";
			
		setVisibility("ipoddialog", false);
		setVisibility("deletedialog", false);
		resultDialog(result);
	} else {
		// make pod green?
	}
}









/* Dialogs */

function regWindow() {
	toggleVisibility("regdialog");
}

function deleteQuery() {
	toggleVisibility("deletedialog");
	toggleVisibility("controls");
	toggleVisibility("searchicon");
	toggleVisibility("gearicon");
	toggleVisibility("newicon");
	if (iPod != '')
		toggleVisibility('ipodicon');
}

function deleteYes() {
	deleteQuery();
	deletePage(openPage);
}

function resultDialog(str) {
	setVisibility("controls", false);
	setVisibility("searchicon", false);
	setVisibility("gearicon", false);
	setVisibility("deleteicon", false);
	setVisibility("newicon", false);
	if (iPod != '')
		setVisibility('ipodicon', false);

	document.getElementById("resulttext").innerHTML = str;
	setVisibility("result", true);

}

function resultDialogOK() {
	setVisibility("controls",true);
	setVisibility("searchicon",true);
	setVisibility("gearicon",true);
	setVisibility("deleteicon", true);
	setVisibility("newicon",true);
	if (iPod != '')
		setVisibility('ipodicon',true);
		
	setVisibility('result', false);
}


function openPassDialog() {
	if (widget.preferenceForKey("lock-password") != undefined)
		document.getElementById("lockpassword").value = "stored";
	else
		document.getElementById("lockpassword").value = "";
		
	toggleVisibility('lockdialog');
}

function setPassDialogCancel() {
	toggleVisibility('lockdialog');
	document.getElementById("lockpassword").value = "";
}


function setPassDialogOK() {
	if (document.getElementById("lockpassword").value == "")
		return;
	
	if (document.getElementById("lockpassword").value == "stored" && widget.preferenceForKey("lock-password") == "")
		return;
	
	
	if (document.getElementById("lockpassword").value != "stored") {
		widget.setPreferenceForKey(Notebook.hashPassword(document.getElementById("lockpassword").value), "lock-password");
		document.getElementById("lockpassword").value = "stored";
	}
	
	widget.setPreferenceForKey(true, "lock-enabled");
	fipped = false;
	
	widget.prepareForTransition("ToFront");
	toggleVisibility('lockdialog');
	toggleVisibility('closed');
	toggleVisibility('back');
	setTimeout ('widget.performTransition();', 0);
}

function unLock() {
	if (Notebook.hashPassword(document.getElementById("unlockpassword").value) == widget.preferenceForKey("lock-password")) {
		toggleVisibility('front');
		toggleVisibility('closed');
		widget.setPreferenceForKey(false, "lock-enabled");
		
		if (isDrawing)
			replay();
	} else 
		toggleVisibility('badpassword');
	
	
	
	document.getElementById("unlockpassword").value = "";
}








/* Utilities */


function waitCursor(what) {
	if (what)
		document.body.style.cursor="wait";
	else
		document.body.style.cursor="auto";
}

function toggleVisibility(what) {
	if (document.getElementById(what).style.display=="none")
		document.getElementById(what).style.display="block";
	else
		document.getElementById(what).style.display="none";
}

function setVisibility(what, boo) {
	if (boo)
		document.getElementById(what).style.display="block";
	else
		document.getElementById(what).style.display="none";
}

function isVisible(what) {
	return (document.getElementById(what).style.display=="block");
}

function trim(str) {
	return str.replace(/^\s*|\s*$/g,"");
}

function forceRepaint() {
	var v = document.body.offsetHeight;
}

function forceAsync() { /* blank */ }









/* Drawing */

var canvas;
var context;
var pensize = 1;
var pencolor = 1;
var isDown = false;
var line = "";

function fixCanvasSize() {
	document.getElementById('draw').width = document.getElementById('draw').offsetWidth;
	document.getElementById('draw').height = document.getElementById('draw').offsetHeight;
}

function drawing_pensize() {
	pensize++;
	if (pensize==4)
		pensize = 7;
	else if (pensize>3)
		pensize = 1;
	
	document.getElementById('pensize').style.backgroundPositionX = (-(pensize-1)*16)+"px";
	
	context.lineWidth = pensize;
}


function drawing_pencolor() {
	pencolor++;
	if (pencolor>5)
		pencolor = 1;
	
	document.getElementById('pencolor').style.backgroundPositionX = (-(pencolor-1)*16)+"px";
	
	context.strokeStyle = drawing_getcolor(pencolor);
}

function drawing_getcolor(pencolor) {
	switch (parseInt(pencolor)) {
		case 1:		return "#000000";
		case 2:		return "#880000";
		case 3:		return "#008800";
		case 4:		return "#000088";
		case 5:		return "#EEEEEE";
		default:	return "#000000";
	}
}

function setupDraw() {
	if (canvas == undefined) {
		canvas = document.getElementById("draw");
		canvas.onmousemove = movecanvas;
		canvas.onmousedown = clickcanvas;
		canvas.onmouseup = clickupcanvas;
		document.captureEvents(Event.MOUSEMOVE);
	}
	
	if (context == undefined) {
		context = canvas.getContext("2d");
	}
	
	context.lineWidth = pensize;
	context.strokeStyle = drawing_getcolor(pencolor);
}

function movecanvas(e) {
	if (!isDown)
		return true;
	
	tempX = e.offsetX;
	tempY = e.offsetY;
	
	if (tempX < 0){tempX = 0}
	if (tempY < 0){tempY = 0}  
	
	context.lineTo(tempX, tempY);
	context.stroke();
	context.beginPath();
	context.moveTo(tempX, tempY);
	
	line += tempX+','+tempY+';';
	return true;
}

function clickcanvas(e) {
	context.lineWidth = pensize;
	context.strokeStyle = drawing_getcolor(pencolor);
	
	tempX = e.offsetX;
	tempY = e.offsetY;
	
	context.beginPath();
	context.moveTo(tempX-(pensize/2), tempY);
	context.lineTo(tempX+(pensize/2), tempY);
	context.stroke();
	context.beginPath();
	context.moveTo(tempX, tempY);

	isDown = true;
	line = pensize+','+pencolor+';'+e.offsetX+','+e.offsetY+';';
}

function clickupcanvas(e) {
	if (!isDown)
		return true;
		
	context.stroke();
	context.save();
	
	isDown = false;
	line += e.offsetX+','+e.offsetY+';';
	document.getElementById('edit').value = document.getElementById('edit').value + "-" + line;
	
	hasChanged();
}

function replay() {	
    forceRepaint();
	context.clearRect(0,0,1024,1024);
	var lines = document.getElementById('edit').value.split('-');
	
	for (var j = 1; j < lines.length; j++) {
		var tempLine = lines[j];
		var points = tempLine.split(';');
		var axes = points[0].split(',');
		
		var pensize = parseInt(axes[0]);
		if (axes[0]==4) {
			context.lineWidth = pensize;
			context.strokeStyle = "#EEEEEE";
		} else {
			context.lineWidth = pensize;
			context.strokeStyle = drawing_getcolor(axes[1]);
		}
		
		axes = points[1].split(',');

		axes[0] = parseInt(axes[0]);
		axes[1] = parseInt(axes[1]);
		
		context.beginPath();
		context.moveTo(axes[0]-(pensize/2), axes[1]);
		context.lineTo(axes[0]+(pensize/2), axes[1]);
		context.stroke();
		context.beginPath();
		context.moveTo(axes[0], axes[1]);
		
		
		for (var i = 2; i < points.length-1; i++) {
			axes = points[i].split(',');
			
			context.lineTo(axes[0], axes[1]);
			context.stroke();
			context.beginPath();
			context.moveTo(axes[0], axes[1]);
		}
		
		context.stroke();
	}
	
	context.save();
	context.lineWidth = pensize;
	context.strokeStyle = drawing_getcolor(pencolor);
}






/* Lists */

function todoPress(event) {
	if (event.keyCode==13) {
		if (event.target.parentNode.nextSibling.tagName=="SPAN")
			additem('Untitled', 'O', true);
		else {
			event.target.parentNode.nextSibling.childNodes[1].focus();
			event.target.parentNode.nextSibling.childNodes[1].select();
		}
			
		return false;
	} else if (event.keyCode==8 && event.target.innerHTML.length<1) {
		if (event.target.parentNode.previousSibling!=null && event.target.parentNode.previousSibling.childNodes[1]!=null)
			event.target.parentNode.previousSibling.childNodes[1].focus();
		else if (event.target.parentNode.nextSibling!=null && event.target.parentNode.nextSibling.childNodes[1]!=null)
			event.target.parentNode.nextSibling.childNodes[1].focus();
		else {
			event.target.innerHTML = "Untitled";
			return false;
		}
			
		event.target.parentNode.parentNode.removeChild(event.target.parentNode);
		return false;
	}
	
	hasChanged();
	return true;
}

function todoBlur(event) {
	if (event.target.innerHTML.length<1) {
		if (event.target.parentNode.previousSibling!=null && event.target.parentNode.previousSibling.childNodes[1]!=null)
			;
		else if (event.target.parentNode.nextSibling!=null && event.target.parentNode.nextSibling.childNodes[1]!=null)
			;
		else {
			event.target.innerHTML = "Untitled";
			return false;
		}
			
		event.target.parentNode.parentNode.removeChild(event.target.parentNode);
		return false;
	}
}

function replayList() {
	var content = document.getElementById('listcontents');
	
	for (var i = content.childNodes.length-1; i >= 0; i--) {
		if (content.childNodes[i].className == 'todo') {
			content.childNodes[i].parentNode.removeChild(content.childNodes[i]);
		}
	}

	var list = document.getElementById('edit').value.split("\n");
		
	for (var i = 0; i < list.length; i++) {
		if (list[i] != "")
			additem(list[i].substring(2), niceToUgly(list[i].substring(0,1)));
	}
}

function toggleprio (e) {
	var item = e.srcElement;
	
	if (item.className == 'prio O')
		item.className = 'prio X';
	else
		item.className = 'prio O';

 	e.stopPropagation();
}

function cancelclick (e) {
	e.stopPropagation();

}

function additem(name, prio, hilite) {
	var insertHere = document.getElementById('writeroot');
	var newFields = document.getElementById('readroot').cloneNode(true);
	newFields.style.display = 'block';
	newFields.childNodes[0].onclick = toggleprio;
	newFields.childNodes[0].className = 'prio '+prio;
	newFields.childNodes[1].onclick = cancelclick;
	newFields.childNodes[1].innerHTML = name;
	newFields.childNodes[1].style.fontFamily = widget.preferenceForKey("font-face");
	newFields.childNodes[1].style.fontSize = widget.preferenceForKey("font-size");
	insertHere.parentNode.insertBefore(newFields,insertHere);
	
	if (hilite) {
		newFields.childNodes[1].focus();
	}
}

function saveItems() {
	var content = document.getElementById('listcontents');
	var s = ""; 
	
	for (var i = 0; i < content.childNodes.length; i++) {
		if (content.childNodes[i].className == 'todo' || content.childNodes[i].className == 'todo hilited') { 
			var todoNode = content.childNodes[i];
			if (todoNode.childNodes[0] != null) {
				var t = todoNode.childNodes[0].className.split(' ');
				var value = uglyToNice(t[1])+" "+todoNode.childNodes[1].innerHTML;
				s += value + "\n";
			}
		}
	}
	
	document.getElementById('edit').value = s;
}

function niceToUgly(x) {
	return (x=="•")?'O':'X';
}

function uglyToNice(x) {
	return (x=="O")?'•':'√';
}






/* Tutorial */
var help_running = false;

function getOffsetTop(element) {
	var top = 0;
	var el = element;
	
	do {
		top += el.offsetTop;
		el = el.parentNode;
	} while (el !== document.body);
	
	return top;
}

function getOffsetLeft(element) {
	var left = 0;
	var el = element;
	
	do {
		left += el.offsetLeft;
		el = el.parentNode;
	} while (el !== document.body);
	
	return left;
}

var help_canvas_pen, help_canvas_x_stretch, help_canvas_y_stretch;

function showHelp() {
	help_running = true;

	hidePrefs();
	
	/* If the search tab is visible, hide it */
	if (document.getElementById('searchtab').style.display!="none")
		togglesearch(false);
		
	/* Hide dialog boxes */
	if (document.getElementById('deletedialog').style.display!="none")
		deleteQuery();
	
	document.getElementById("cover").style.display = "block";
	helpCircleEdit();
}

function helpCircleEdit() {
	circleObject('edit',
		function () {
			showHelpText(0,
				function () {
					setTimeout( "helpCircleNewIcon()", 10000);
				}
			)
		}
	);
}

function helpCircleNewIcon() {
	hideHelpText(0,
		function () {
			circleObject('newicon',
				function () {
					showHelpText(1,
						function () {
							setTimeout( "helpCircleDeleteIcon()", 5000)
						}
					)
				}
			)
		}
	);
}

function helpCircleDeleteIcon() {
	hideHelpText(1,
		function () {
			circleObject('deleteicon',
				function () {
					showHelpText(2,
						function () {
							setTimeout( "helpCirclegearicon()", 5000)
						}
					)
				}
			)
		}
	);
}

function helpCirclegearicon() {
	hideHelpText(2,
		function () {
			circleObject('gearicon',
				function () {
					showHelpText(3,
						function () {
							setTimeout( "helpCircleSearchIcon()", 5000)
						}
					)
				}
			)
		}
	);
}

function helpCircleSearchIcon() {
	hideHelpText(3,
		function () {
			circleObject('searchicon',
				function () {
					showHelpText(4,
						function () {
							setTimeout( "helpCircleNavIcon()", 5000)
						}
					)
				}
			)
		}
	);
}

function helpCircleNavIcon() {
	hideHelpText(4,
		function () {
			circleObject('controls',
				function () {
					showHelpText(5,
						function () {
							setTimeout( "helpCircleGrowIcon()", 10000)
						}
					)
				}
			)
		}
	);
}

function helpCircleGrowIcon() {
	hideHelpText(5,
		function () {
			circleObject('grow',
				function () {
					showHelpText(6,
						function () {
							setTimeout( "helpCircleFlipIcon()", 4000)
						}
					)
				}
			)
		}
	);
}

function helpCircleFlipIcon() {
	hideHelpText(6,
		function () {
			circleObject('rollie',
				function () {
					showHelpText(8,
						function () {
							setTimeout( "helpThanks()", 5000)
						}
					)
				}
			)
		}
	);
}

function helpThanks() {
	hideHelpText(8,
		function () {
			document.getElementById("help_circle_canvas").style.display = "none";
					showHelpText(7,
						function () {
							setTimeout( "helpDone()", 4000)
						}
					)
		}
	);
}


function helpDone() {
	hideHelpText(7, null);
	document.getElementById("help_circle_canvas").style.display = "none";
	document.getElementById("cover").style.display = "none";

	showPrefs();
}



function cancelHelp() {
	help_running = false;
	document.getElementById("help_circle_canvas").style.display = "none";
	document.getElementById("help_text_"+language).style.display = "none";
	document.getElementById("cover").style.display = "none";
}

function handleKeyPress(e) {
	if (e.charCode == 27 && help_running) cancelHelp();
}

function circleObject(obj, callBack) {
	if (!help_running) return false;
	
	if (obj == new String(obj)) obj = document.getElementById(obj);
	
	help_canvas = document.getElementById("help_circle_canvas");
	
	help_canvas.style.display = "block";
	var help_context = help_canvas.getContext("2d");
	
	help_canvas.style.top = (getOffsetTop(obj) - 3) + "px";
	help_canvas.style.left = (getOffsetLeft(obj) - 3) + "px";
	help_canvas.style.bottom = "0 px";
	help_canvas.style.right = "0 px";
	
	help_context.lineWidth = 1;
	help_context.lineJoin = "bevel";
	help_context.lineCap = "round";
	help_context.strokeStyle = "rgba(255, 0, 0, 0.8)";
	
	help_context.clearRect(0, 0, 1000, 1000);
	help_context.save();
	
	if (parseInt(document.defaultView.getComputedStyle(obj, '').getPropertyValue("width")) > 20) {
		help_canvas_x_stretch = parseInt(document.defaultView.getComputedStyle(obj, '').getPropertyValue("width"))/30;
	} else {
		help_canvas_x_stretch = 1;
	}
	
	if (parseInt(document.defaultView.getComputedStyle(obj, '').getPropertyValue("height")) > 20) {
		help_canvas_y_stretch = parseInt(document.defaultView.getComputedStyle(obj, '').getPropertyValue("height"))/30;
	} else {
		help_canvas_y_stretch = 1;
	}
	
	help_context.scale(help_canvas_x_stretch, help_canvas_y_stretch);
	
	help_context.beginPath();
	help_context.moveTo(5, 10);
	
	var i=0;
	
	var inter = setInterval(
		function () {
			//alert(i);
			switch (i) {
				case 0:
					help_context.bezierCurveTo(5, 0, 20, 10, 20, 20);
					break;
				case 1:
					help_context.beginPath();
					help_context.moveTo(20, 10);
					help_context.bezierCurveTo(30, 20, 20, 30, 15, 20);
					break;
				case 2:
					help_context.beginPath();
					help_context.moveTo(20, 30);
					help_context.bezierCurveTo(10, 35, 5, 25, 5, 10);
					break;
				case 3:
					help_context.beginPath();
					help_context.moveTo(5, 25);
					help_context.bezierCurveTo(2, 7, 9, 10, 0, 0);
					break;
				//Default:
				case 4:
					clearInterval(inter);
					help_context.restore();
					if (callBack != null) callBack();
					break;
			}
			help_context.stroke();
			i++;
		}, 70);
}

function showHelpText(which, callBack) {
	if (!help_running) return false;
	
	var help_text = document.getElementById("help_text_"+language);
	help_text.style.display = "block";
	
	var messages = help_text.getElementsByTagName("div");
	if (which > 0) messages[which-1].style.opacity = 0;
	
	fade(messages[which], 0, 0.9, 
		function() {
			//setTimeout("help_text_shadow.paint()", 100);
			callBack();
		});
}

function hideHelpText(which, callBack) {
	var help_text = document.getElementById("help_text_"+language);
	
	
	var messages = help_text.getElementsByTagName("div");
	//if (which > 0) messages[which-1].style.opacity = 0;
	
	fade(messages[which], 0.9, 0, 
		function () {
			help_text.style.display = "none";
			callBack();
		});
}





function cmdKeyHandler(e) {
	//alert('pressed  '+String.fromCharCode(e.keyCode)+'-'+e.keyCode);
	if (window.event.metaKey) {
		switch (String.fromCharCode(e.keyCode)) {
			case 'F':
				togglesearch(!searchOpen);
				break;
				
			case 'N':
				if (window.event.shiftKey)
				{	newDrawingPage();	}
				else if (window.event.altKey)
				{	newListPage();	}
				else
				{	newPage();		}
					
				break;
				
			case 'P':
				printPage(openPage);
				break;
				
			case 'S':
				if (window.event.shiftKey)
					saveAs();
				else {
					savePage(openPage);
					forceRepaint();
					return false;
				}
				
				break;
			
			case '+':
			case 'k':
			case '»': // check for text or drawing
				if (isDrawing)
					drawing_pensize();
				else {
					store();
					text_sizeup();
				}
				break;
				
			case '-':
			case 'm':
			case '½':
				if (isDrawing)
					drawing_pencolor();
				else {
					store();
					text_sizedown();
				}
				break;
						
			case String.fromCharCode(8): // backspace
				deleteQuery();
				break;
		}
	}
}

document.onkeydown = cmdKeyHandler;






/* Fade (for help text) */
function fade(el, from, to, callBack) {
    if (el == new String(el)) el = document.getElementById(el);
    //so we can pass a string for the id or an element
     
    if (from == -1) // kalleboo mod
     	from = el.style.opacity;
     
    var dif = Math.abs(to - from);
    
    var pi = Math.PI;
    var theta = 0;
    
    //if (to < from && el.style.opacity > 0) return;
    
	var inter = setInterval(
		function() {
			if (theta < 90) {
				theta += 10;
				if (to > from) 
					var step = Math.sin((theta*pi)/180);
				else 
					var step = Math.cos((theta*pi)/180);
				var opac = dif*step;
				el.style.opacity = Math.max(0.01, opac); //fixing safari glitch
			} else {
				el.style.opacity = to;
				clearInterval(inter);
				if (callBack != null) callBack();
			}
		}, 100);
}

/* Quicker fade (for hiding controls) */
function qfade(el) {
	el = document.getElementById(el);
     
    var from = el.style.opacity;
	var to = getTO();

    var pi = Math.PI;
    var theta = 0;

	var inter = setInterval(
		function() {
			to = getTO();
			
			if (theta < 90) {
				theta += 20;
				if (to > from) 
					var step = Math.sin((theta*pi)/180);
				else 
					var step = Math.cos((theta*pi)/180);
					
				var opac = Math.abs(to - from) * step;
				el.style.opacity = Math.max(0.01, opac); //fixing safari glitch
			} else {
				el.style.opacity = getTO();
				clearInterval(inter); // inter
			}
		}, 50);
		
	return inter;
}







function loadFontPopup() {
	var fontList = Notebook.getFontList();
	var popup = document.getElementById("fontface");
		
	popup.options[0] = new Option("Lucida Grande");
	for (var i = 0; i < fontList.length; i++) {
		popup.options[i+1] = new Option(fontList[i]);
	}
}



function setFont() {
	document.getElementById("origlabel").style.minHeight = widget.preferenceForKey("font-size");
	document.getElementById("edit").style.fontFamily = document.getElementById("fontface").value;
	document.getElementById("edit").style.fontSize = document.getElementById("fontsize").value;
	document.getElementById("searchresults").style.fontFamily = document.getElementById("fontface").value;
	document.getElementById("searchresults").style.fontSize = document.getElementById("fontsize").value;
	widget.setPreferenceForKey(document.getElementById("fontface").value, "font-face");
	widget.setPreferenceForKey(document.getElementById("fontsize").value, "font-size");
	
	if (isList) {
		replayList();
	}
		
}

function text_sizeup() {
	var popup = document.getElementById("fontsize");
	var i = popup.selectedIndex+1;
	
	if (i == popup.options.length)
		i--;
	
	popup.selectedIndex = i;
	
	setFont();
}

function text_sizedown() {
	var popup = document.getElementById("fontsize");
	var i = popup.selectedIndex-1;
	
	if (i == -1)
		i++;
	
	popup.selectedIndex = i;
	
	setFont();
}


function setTheme() {
	var theme = document.getElementById("theme").selectedIndex;
	widget.setPreferenceForKey(theme, "theme");
	
	var stylesheets = document.getElementsByTagName('link');
	theme+=2;
	
	for (var i=2; i<stylesheets.length; i++) {
		stylesheets[i].disabled = !(i == theme);
	}
}




/* FLIP */
function showPrefs() {
	flipped = true;
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
}

function hidePrefs() {
	fipped = false;
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (isDrawing)
		replay();
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}






/* RESIZE */
function minwidth() 	{	return 258;	}
function minheight() 	{	return 261;	}

function maxwidth() 	{	return 1600;	}
function maxheight() 	{	return 1200;	}

var lastPos;		// tracks where the last mouse position was throughout the drag

function mouseDown(event) {

	var x = event.x + window.screenX;		// the placement of the click
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);  	// begin tracking the move
	document.addEventListener("mouseup", mouseUp, true);		// and notify when the drag ends

	lastPos = {x:x, y:y};		// track where the initial mouse down was, for later comparisons
								// the mouseMove function

	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event) {	

	var screenX = event.x + window.screenX;		// retrieves the current mouse position
	var screenY = event.y + window.screenY;
		
	var deltaX = 0;		// will hold the change since the last mouseMove event
	var deltaY = 0;

	deltaX = screenX - lastPos.x;
	lastPos.x = screenX;

	deltaY = screenY - lastPos.y;
	lastPos.y = screenY;
	
	if (window.innerWidth+deltaX > maxwidth())
		deltaX = maxwidth()-window.innerWidth;
	
	if (window.innerWidth+deltaX < minwidth())
		deltaX = minwidth()-window.innerWidth;
		
	if (window.innerHeight+deltaY > maxheight())
		deltaY = maxheight()-window.innerHeight;
	
	if (window.innerHeight+deltaY < minheight())
		deltaY = minheight()-window.innerHeight;
	
	window.resizeBy(deltaX, deltaY);	// resizes the widget to follow the mouse movement

	if (isDrawing) {
		fixCanvasSize();
		replay();
	}
	
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);	

	widget.setPreferenceForKey(window.outerWidth, "pad-width");
	widget.setPreferenceForKey(window.outerHeight, "pad-height");

	event.stopPropagation();
	event.preventDefault();
}

/* Reg */

function clearOnFocus(field, defval) {
	if (document.getElementById(field).value == defval) {
		document.getElementById(field).value = "";
		document.getElementById(field).style.color = "black";
	}
}

function regSubmit() {
	if (Notebook.doRegister(document.getElementById('regname').value,document.getElementById('regcode').value)) {
		toggleVisibility("regdialog");
		hideStickers();
		toggleVisibility("thanksdialog");
	} else {
		toggleVisibility("regdialog");
		toggleVisibility("regfaildialog");
	}
}

function hideStickers() {
	document.getElementById("backreground").style.display = "none";
	document.getElementById("backbuynow").style.display = "none";
}

function showNag(days_left) {
	isNagging = true;
	
	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "none";
	window.resizeTo(341, 134);
	forceRepaint();
	
	//I'll forgo doing this in a nice DOM way for the moment:
	var cont = document.createElement("div");
	cont.id = "buy_panel";
	
	var buy_p_text =  document.createElement("div");
	buy_p_text.id = "buy_panel_text";
	cont.appendChild(buy_p_text);
	
	buy_p_text.innerHTML += getLocalString("daysleft_pre") + '<span id="widget_name">Notebook</span>' + getLocalString("daysleft_mid") + days_left + getLocalString("daysleft_post");
	if (10 - days_left != 1) buy_p_text.innerHTML += getLocalString("daysleft_plural");
	buy_p_text.innerHTML += '.<br />'+getLocalString("daysleft_thanks")+'\n';
	var buy_p_buts =  document.createElement("div");
	buy_p_buts.id = "buy_buttons";
	cont.appendChild(buy_p_buts);
	
	buy_p_buts.innerHTML += '<a href="#" onclick="javascript:widget.openURL(\'http://www.kalleboo.com/?Notebook%20Widget\')">'+getLocalString("buy")+'</a>\n';
//	buy_p_buts.innerHTML += '<a href="#" onclick="regWindow()">'+getLocalString("register")+'</a>\n';
	
	var counter = document.createElement("span");
	counter.id = "counter";
	counter.innerText = 7;
	
	buy_p_buts.appendChild(counter);
	
	document.body.appendChild(cont);
	
	var count_down = 7;
	
	var inter = setInterval(
		function () {
			if (--count_down >= 0) {
				counter.innerText = count_down;
			} else {
				clearInterval(inter);
				window.resizeTo(250, 230);
				if (!flipped) {
					document.getElementById("front").style.display = "block";
				} else {
					document.getElementById("back").style.display = "block";
					//document.getElementById("register_buy").style.display = "block";
				}
				
				document.body.removeChild(cont);
				load();
			}
		}, 1000);
}